package fitconnect.api.domain.metadata;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import fitconnect.api.domain.metadata.attachment.Attachment;
import fitconnect.api.domain.metadata.data.Data;

import java.util.List;
import java.util.Map;

/**
 * Beschreibt die Struktur der zusätzlichen Inhalte der Einreichung, wie Anlagen oder Fachdaten.
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
        "data",
        "attachments"
})
public record ContentStructure(

        @JsonProperty("data")
        Data data,

        @JsonProperty("attachments")
        List<Attachment> attachments,

        @JsonIgnore
        Map<String, Object> additionalProperties
) { }
