package fitconnect.api.domain.metadata.attachment;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import fitconnect.api.domain.metadata.attachment.signature.Hash__1;
import fitconnect.api.domain.metadata.attachment.signature.Signature__1;

import java.util.Map;
import java.util.UUID;


/**
 * Eine in der Einreichung enthaltene Anlage.
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
        "hash",
        "signature",
        "purpose",
        "filename",
        "description",
        "mimeType",
        "attachmentId"
})
public record Attachment(

        @JsonProperty("hash")
        Hash__1 hash,

        @JsonProperty("signature")
        Signature__1 signature,

        @JsonProperty("purpose")
        Purpose purpose,

        @JsonProperty("filename")
        String filename,

        @JsonProperty("description")
        String description,

        @JsonProperty("mimeType")
        String mimeType,

        @JsonProperty("attachmentId")
        UUID attachmentId,

        @JsonIgnore
        Map<String, Object> additionalProperties
) { }


