package fitconnect.api.validation;

import com.nimbusds.jose.jwk.RSAKey;

/**
 * Validator for publicKeys and certificate chains
 * For further information see: <a href="https://docs.fitko.de/fit-connect/docs/sending/encrypt/#certificateValidation">Certificate Validation</a>
 */
public interface CertificateValidator {

    /**
     *
     * @param publicKey the public encryption key that is validated
     * @return a result that includes errors if the validation failed
     */
    ValidationResult validatePublicKey(final RSAKey publicKey);
}
