package fitconnect.api.validation;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Wrapper for validations including errors that occurred
 */
public class ValidationResult {

    private boolean isValid;
    private List<Exception> errors;

    private ValidationResult(final boolean isValid) {
        this.isValid = isValid;
        this.errors = Collections.emptyList();
    }

    private ValidationResult(final boolean isValid, Exception... exceptions) {
        this.isValid = isValid;
        this.errors = Arrays.asList(exceptions);
    }

    public static ValidationResult ok() {
        return new ValidationResult(true);
    }

    public static ValidationResult error(Exception... exceptions) {
        return new ValidationResult(false, exceptions);
    }

    public boolean isValid() {
        return this.isValid;
    }
}
