package de.fitconnect.client;

import fitconnect.api.Sender;
import fitconnect.api.auth.OAuthToken;
import fitconnect.api.logger.SdkLogger;

import java.util.Optional;
import java.util.logging.Level;
import java.util.logging.Logger;

public class FitConnectSenderClient {

    private static final Logger logger = SdkLogger.defaultLogger(FitConnectSenderClient.class);

    private final Sender sender;
    private Optional<OAuthToken> token = Optional.empty();

    public FitConnectSenderClient(){
        this.sender = ClientFactory.submissionSender();
    }
    
    public FitConnectSenderClient authenticate(String clientId, String secret, String...scope){
        this.token = sender.retrieveOAuthToken(clientId,secret,scope);
        return this;
    }

    public FitConnectSenderClient createSubmission(){
        checkIfAuthenticated();
        // TODO implement
        return this;
    }

    public FitConnectSenderClient sendSubmission(){
        checkIfAuthenticated();
        // TODO implement
        return this;
    }

    public FitConnectSenderClient printToken(){
        checkIfAuthenticated();
        logger.log(Level.INFO, "retrieved access token: " + this.token.get().access_token());
        return this;
    }

    private void checkIfAuthenticated() {
        if(token.isEmpty()){
            throw new IllegalStateException("authenticate first");
        }
    }

}
